/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
/**
 * test_runner.c
 *
 *  \date       Jun 7, 2019
 *  \author    	<a href="mailto:dev@celix.apache.org">Apache Celix Project Team</a>
 *  \copyright	Apache License, Version 2.0
 */

#include <unistd.h>

#include "celix_api.h"

#include <CppUTest/TestHarness.h>
#include <CppUTest/CommandLineTestRunner.h>

celix_framework_t *fw = nullptr;


int main(int argc, char **argv) {
    celixLauncher_launch("config.properties", &fw);
    //usleep(1000000);

    MemoryLeakWarningPlugin::turnOffNewDeleteOverloads();
    int rc = RUN_ALL_TESTS(argc, argv);

    celixLauncher_stop(fw);
    celixLauncher_waitForShutdown(fw);
    celixLauncher_destroy(fw);

    return rc;
}